﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace RealTimeUpdateDemo
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        DataGenerator view = new DataGenerator();
        DispatcherTimer timer = new DispatcherTimer();
        
        public MainPage()
        {
            this.InitializeComponent();
            this.Chart1.Series[0].ItemsSource = view.DynamicData;
            timer.Tick += timer_Tick;
            timer.Interval = new TimeSpan(0,0,0,1);
        }

        void timer_Tick(object sender, object e)
        {
            int d = view.randomNumber.Next(0, 2);
            normal();
            if (d == 0)
            {
                slow();

            }
            else if (d == 1)
            {
                fast();
            }
            normal();
        }

       
        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        

       
        private void SlowPluse_Click(object sender, RoutedEventArgs e)
        {
            normal();  
            slow();
            normal();  

        }

        private void FastPluse_Click(object sender, RoutedEventArgs e)
        {
            normal();
            fast();
            normal();
        }
       
        private void NormalPluse_Click(object sender, RoutedEventArgs e)
        {
            normal();          
        }
        void fast()
        {
            view.DynamicData.Add(new Data("Fast", view.randomNumber.Next(50, 100)));
            
        }
        void slow()
        {
            view.DynamicData.Add(new Data("Slow", view.randomNumber.Next(0, 50)));

        }
        void normal()
        {
            view.DynamicData.Add(new Data("Normal", 50));     
        }
        private void StartPulse_Click(object sender, RoutedEventArgs e)
        {
            timer.Start();
        }

        private void StopPulse_Click(object sender, RoutedEventArgs e)
        {
            timer.Stop();
        }

       
       

    }

    public class DataGenerator
    {
        public int DataCount = 10;
        
        public Random randomNumber;
        public ObservableCollection<Data> DynamicData { get; set; }
        List<string> PulseCases = new List<string>() { "Slow", "Fast", "Normal" };
        public DataGenerator()
        {
            randomNumber = new Random();
            DynamicData = new ObservableCollection<Data>();
            DynamicData.Add(new Data(PulseCases[2], 50));
            GenerateData();
            randomNumber = new Random();
        }
       
        void GenerateData()
        {
            for (int i = 0; i < this.DataCount; i++)
            {
                int d = randomNumber.Next(0,2);
                double pulsevalue = 50;
                if (d == 0)
                {
                    pulsevalue = randomNumber.Next(0, 50);
                  
                }
                else if (d == 1)
                {
                    pulsevalue = randomNumber.Next(50, 100);
                }
                DynamicData.Add(new Data(PulseCases[2], 50));
                DynamicData.Add(new Data(PulseCases[d], pulsevalue));
                DynamicData.Add(new Data(PulseCases[2], 50));
                
                              
            }

          
        }
    }

    public class Data
    {
        public Data(string pulsecase, double value)
        {
            PulseCase = pulsecase;           
            Value = value;
          
        }
        public string PulseCase { get; set; }

      

        public double Value
        {
            get;
            set;
        }
      
    }   
}
